; OSD-mute
; To monitor and display status when mute
; Date: 05/07/2007  ;Last Updated: 12/06/2008
; Refer: hxxp://www.donationcoder.com/Forums/bb/index.php?topic=9094.0
; Gui code based on: hxxp://www.autohotkey.com/forum/viewtopic.php?t=9685
; majkinetor's CmnDlg: hxxp://www.autohotkey.com/forum/topic17230.html
;
; Changes since:
; Added INI options - notraymenu, noquitmenu
; Customisation of font, font color and font size
; positioning on the screen (relative)
;
; Updated systray icon to reflect the current status.
; Check for sndvol32.exe, error-trapping precaution. 
; Incorporate Nod5's suggestion to remove flickering.
; ---------------------------------------------------
; Minor features updates
; - Allow click-through
; - stop Win+D from minimizing the Gui
; - tray icon to emulate normal tray volume icon
;
FileInstall CmnDlg.ahk, CmnDlg.ahk 

#SingleInstance force
#Persistent
#Include %A_ScriptDir%\CmnDlg.ahk
;#NoTrayIcon

appname=OSD-Mute
INI_File=%appname%.ini
Gosub, Get_INI
If notraymenu=1
  Menu, tray, NoIcon
Else
  Gosub, Script_Menu
SetTimer, WatchMute, 500  ;increase or decrease timer
Return

Script_Menu:
;Menu, tray, Icon, %A_WinDir%\System32\sndvol32.exe, 4 ; Mute icon
;Menu, tray, NoIcon
Menu, tray, NoStandard
Menu, tray, Tip, %appname%`, Monitor and display system's Mute status.
Menu, tray, Add, Open Volume Control, VolumeSettings  ; Open Volume Control
Menu, tray, Add, Adjust Audio Properties, AudioProperties ; Adjust Audio Properties
Menu, tray, Add, 
Menu, tray, Add, Customize OSD, CustomGUI
;
Menu, SubMenu, Add, Top-Left, TextShow
Menu, SubMenu, Add, Top-Right, TextShow
Menu, SubMenu, Add, Bottom-Left, TextShow
Menu, SubMenu, Add, Bottom-Right, TextShow
Menu, tray, Add, OSD Position, :SubMenu 
If noquitmenu=0
  Menu, tray, Add, Quit OSD, #q
;
Menu, tray, Add, 
Menu, tray, Add, Visit the discussion forum for %appname%, DC-Forum  ;About Box
 
Menu, Tray, Default, Open Volume Control
Return

Get_INI:
IfNotExist, %INI_File%
  {
  comments=
  comments=`;%A_Space%Ini settings for "OSD-mute" script.
  comments=%comments%`n`;%A_Space%
  comments=%comments%`n`;%A_Space%This file contains the configurable settings.
  comments=%comments%`n`;%A_Space%such as font, font color and font size. :)
  comments=%comments%`n`;%A_Space%--------------------------------------
  comments=%comments%`n`;%A_Space%You may edit this file but not while the script is running.
  comments=%comments%`n`;
  FileAppend,%comments%,%INI_File%
  ;default setting
  fontname=Tahoma
  fontstyle=s30 Bold
  fontcolor=FFD300  ;default orangy color
  posX=70
  posY=600
  margin=30 ; for positioning
  notraymenu=0
  noquitmenu=0
  ;IniWrite, Value, Filename, Section, Key 
  IniWrite,%fontname%,%INI_File%,Settings,FontName
  IniWrite,%fontstyle%,%INI_File%,Settings,FontStyle
  IniWrite,%fontcolor%,%INI_File%,Settings,FontColor
  IniWrite,%fontbgcolor%,%INI_File%,Settings,BgColor
  IniWrite,%posX%,%INI_File%,Settings,posX
  IniWrite,%posY%,%INI_File%,Settings,posY
  IniWrite,%margin%,%INI_File%,Settings,margin
  IniWrite,%notraymenu%,%INI_File%,Settings,notraymenu
  IniWrite,%noquitmenu%,%INI_File%,Settings,noquitmenu
  ;----------------
  FileAppend,`n,%INI_File%
  }
Else  ;INI file exists, read from it
  {
  ;IniRead, OutputVar, Filename, Section, Key [, Default]
  IniRead,fontname,%INI_File%,Settings,FontName,Tahoma
  IniRead,fontstyle,%INI_File%,Settings,FontStyle,s30 Bold
  IniRead,fontcolor,%INI_File%,Settings,FontColor,FFD300
  IniRead,fontbgcolor,%INI_File%,Settings,BgColor,Black
  IniRead,posX,%INI_File%,Settings,posX,70
  IniRead,posY,%INI_File%,Settings,posY,600
  IniRead,margin,%INI_File%,Settings,margin,30
  IniRead,notraymenu,%INI_File%,Settings,notraymenu,0
  IniRead,noquitmenu,%INI_File%,Settings,noquitmenu,0
  ;----------------
  }
Return

VolumeSettings:
Run, %A_WinDir%\System32\sndvol32.exe
Return

AudioProperties:
;Sounds and Audio Devices Properties
Run, RunDll32.exe shell32.dll`,Control_RunDLL mmsys.cpl`,`,0
Return

CustomGUI:
;show font settings
CmnDlg_Font( font := fontname, style := fontstyle, color := fontcolor )
fontname=%Font%
fontstyle=%Style%
fontcolor=%Color%
  ;Save to INI
  IniWrite,%fontname%,%INI_File%,Settings,FontName
  IniWrite,%fontstyle%,%INI_File%,Settings,FontStyle
  IniWrite,%fontcolor%,%INI_File%,Settings,FontColor
  OSD_On = False  ; to re-draw the GUI
GoSub, WatchMute
Return

WatchMute:
SoundGet, CheckMute, , Mute
If CheckMute = On
  {
  If OSD_On = True 
    Return
  Gui, Destroy ;
  Gui, Color, EEAA99
  Gui +AlwaysOnTop +ToolWindow -Caption +LastFound +E0x20
  WinSet, TransColor, EEAA99 105  ;105 - level of translucency (range: 0-255)
  Gui, Font, %fontstyle% c%fontcolor%, %fontname%
  ;Gui, Add, Text, gTextShow x3 y3 w175 h45 Center c000000 BackgroundTrans, Mute %CheckMute%
  ;Gui, Add,Text,x0 y0 w175 h45 Center c%fontcolor% BackgroundTrans, Mute %CheckMute%
  ;Gui,Show, NoActivate x70 y600 w175 h45 ; some crude positioning co-ordinates
  Gui, Add, Text, x3 y3 Center c000000 BackgroundTrans, Mute %CheckMute%
  Gui, Add,Text,x0 y0 Center c%fontcolor% BackgroundTrans, Mute %CheckMute%
  Gui, Show, NoActivate x%posX% y%posY% Autosize
  OnMessage(0x5, "WindowResized")
  OSD_On = True
  IfExist, %A_WinDir%\System32\sndvol32.exe
    Menu, tray, Icon, %A_WinDir%\System32\sndvol32.exe, 4 ; Mute icon
  Sleep, 3000
  }
Else
  {
  OSD_On = False
  Gui, Destroy ;
  IfExist, %A_WinDir%\System32\sndvol32.exe
    Menu, tray, Icon, %A_WinDir%\System32\sndvol32.exe, 5 ; Normal speaker icon
  }
Return

WindowResized(WPARAM, LPARAM, MSG, HWND)
{
    WinRestore, ahk_pid %HWND%
}

DC-Forum:
  Run, http://www.donationcoder.com/Forums/bb/index.php?topic=9094.msg67042#msg67042
  ;Run, http://www.donationcoder.com/Forums/bb/index.php?topic=9094.new#new
Return

TextShow:
SysGet, Monitor, MonitorWorkArea, 1
WinGetPos, WinLeft, WinTop, WinWidth, WinHeight, ahk_class AutoHotkeyGUI

If A_ThisMenuItem=Top-Left
  WinMove, ahk_class AutoHotkeyGUI,, MonitorLeft+margin, MonitorTop+margin 
Else If A_ThisMenuItem=Top-Right
  WinMove, ahk_class AutoHotkeyGUI,, MonitorRight-(WinWidth+margin), MonitorTop+margin
Else If A_ThisMenuItem=Bottom-Left
  WinMove, ahk_class AutoHotkeyGUI,, MonitorLeft+margin, MonitorBottom-(WinHeight+margin)
Else If A_ThisMenuItem=Bottom-Right
  WinMove, ahk_class AutoHotkeyGUI,, MonitorRight-(WinWidth+margin), MonitorBottom-(WinHeight+margin)

WinGetPos, posX, posY, , , ahk_class AutoHotkeyGUI
IniWrite,%posX%,%INI_File%,Settings,posX
IniWrite,%posY%,%INI_File%,Settings,posY
  OSD_On = False  ; to re-draw the GUI
GoSub, WatchMute
Return

;Win+q exits...
#q::ExitApp

